
-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_cameratoae"

-- **************************************************
-- General information about this script
-- **************************************************

DS_cameratoae = {}
function DS_cameratoae:Name()
	return "DS Camera to AE"
end

function DS_cameratoae:Version()
	return "1.0"
end

function DS_cameratoae:Description()
	return "Export camera data to After Effects"
end

function DS_cameratoae:Creator()
	return "dauid.com"
end

function DS_cameratoae:UILabel()
	return("DS Camera to AE")
end


-- **************************************************
-- The guts of this script
-- **************************************************


function DS_cameratoae:OnMouseDown(moho, mouseEvent)
	self:Run(moho)
end

function DS_cameratoae:Run(moho)

local path = LM.GUI.SaveFile("Select Data File")
	if (path == "") then
		return
	end
	
		local f = io.open(path..".txt", "w")

	if (f == nil) then
		return
	end

local width = moho.document:Width()
local height = moho.document:Height()
local aspect = moho.document:AspectRatio()
local newX = (moho.document:Width()/2)
local newY = moho.document:Height()/2
local newZ = moho.document:Height()/2


local fps = moho.document:Fps()
local startframe = moho.document:StartFrame()
local endframe = moho.document:EndFrame()
local campos= LM.Vector3:new_local()
local pantilt = LM.Vector2:new_local()
f:write("Adobe After Effects 8.0 Keyframe Data\n")
f:write("\n\tUnits Per Second\t"..fps)
f:write("\n\tSource Width\t"..width)
f:write("\n\tSource Height\t"..height)
f:write("\n\tSource Pixel Aspect Ratio\t1")
f:write("\n\tComp Pixel Aspect Ratio\t1\n")
--Zoom
f:write("\nCamera Options\tZoom\n")
f:write("\tFrame\tpixels\n")
for i = startframe, endframe do
	local zoom = moho.document.fCameraZoom:GetValue(i)*(1.732*newZ)
	f:write("\t".. i .."\t".. zoom .."\n")
	end 
--Point of interest
f:write("\nTransform\tPoint of Interest\n")
f:write("\tFrame\tX pixels\tY pixels\tZ pixels\n")
	for i = startframe, endframe do
	campos = moho.document.fCameraTrack:GetValue(i)
	if (aspect >0) then
		campos.x = ((campos.x + 1) * newY)+(newX-newY)
		campos.y = ((campos.y*(-1)) + 1) * newY
		campos.z = ((campos.z*(-1))*newZ)+0.1
	else
		campos.x = ((campos.x + 1) * newX)
		campos.y = ((campos.y*(-1)) + 1) * newX + (newY-newX)
		campos.z = ((campos.z*(-1))*newX)+0.1
	end
	f:write("\t".. i .."\t".. campos.x.."\t".. campos.y .."\t".. campos.z .."\n")
	end 
--Position
f:write("\nTransform\tPosition\n")
f:write("\tFrame\tX pixels\tY pixels\tZ pixels\n")
	for i = startframe, endframe do
	campos = moho.document.fCameraTrack:GetValue(i)
	if (aspect >0) then
		campos.x = ((campos.x + 1) * newY)+(newX-newY)
		campos.y = ((campos.y*(-1)) + 1) * newY
		campos.z = ((campos.z*(-1))*newZ)
	else
		campos.x = ((campos.x + 1) * newX)
		campos.y = ((campos.y*(-1)) + 1) * newX + (newY-newX)
		campos.z = ((campos.z*(-1))*newX)
	end
	f:write("\t".. i .."\t".. campos.x.."\t".. campos.y .."\t".. campos.z .."\n")
	end 
--Z rotation
f:write("\nTransform\tRotation\n")
f:write("\tFrame\tdegrees\n")
	for i = startframe, endframe do
	camroll = math.deg(moho.document.fCameraRoll:GetValue(i))
	f:write("\t".. i .."\t".. camroll .."\n")
	end 
--X rotation
f:write("\nTransform\tX Rotation\n")
f:write("\tFrame\tdegrees\n")
	for i = startframe, endframe do
	pantilt = moho.document.fCameraPanTilt:GetValue(i)
	f:write("\t".. i .."\t".. math.deg(pantilt.x) .."\n")
	end 
--Y rotation
f:write("\nTransform\tY Rotation\n")
f:write("\tFrame\tdegrees\n")
	for i = startframe, endframe do
	pantilt = moho.document.fCameraPanTilt:GetValue(i)
	f:write("\t".. i .."\t".. math.deg(pantilt.y)*(-1).."\n")
	end 
f:write("\n\nEnd of Keyframe Data")
f:close() --Close the file
end